'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var _get;

function _load_get() {
  return _get = _interopRequireDefault(require('lodash/get'));
}

var _dateformat;

function _load_dateformat() {
  return _dateformat = _interopRequireDefault(require('dateformat'));
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _fastlane;

function _load_fastlane() {
  return _fastlane = require('./fastlane');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var APPLE_DIST_CERTS_TOO_MANY_GENERATED_ERROR = '\nYou can have only ' + (_chalk || _load_chalk()).default.underline('three') + ' Apple Distribution Certificates generated on your Apple Developer account.\nPlease revoke the old ones or reuse existing from your other apps.\nPlease remember that Apple Distribution Certificates are not application specific!\n';

var createManager = function createManager(_ref) {
  var appleId = _ref.appleId,
      appleIdPassword = _ref.appleIdPassword,
      team = _ref.team;
  return {
    list: function list() {
      var _this = this;

      return (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var args, _ref2, certs;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                args = ['list', appleId, appleIdPassword, team.id, team.inHouse];
                _context.next = 3;
                return (0, (_fastlane || _load_fastlane()).runAction)((_fastlane || _load_fastlane()).travelingFastlane.manageDistCerts, args);

              case 3:
                _ref2 = _context.sent;
                certs = _ref2.certs;
                return _context.abrupt('return', certs);

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }))();
    },
    create: function create() {
      var _this2 = this;

      return (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2() {
        var args, resultString, error;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                args = ['create', appleId, appleIdPassword, team.id, team.inHouse];
                _context2.next = 4;
                return (0, (_fastlane || _load_fastlane()).runAction)((_fastlane || _load_fastlane()).travelingFastlane.manageDistCerts, args);

              case 4:
                return _context2.abrupt('return', _context2.sent);

              case 7:
                _context2.prev = 7;
                _context2.t0 = _context2['catch'](0);
                resultString = (0, (_get || _load_get()).default)(_context2.t0, 'rawDump.resultString');

                if (!(resultString && resultString.match(/Maximum number of certificates generated/))) {
                  _context2.next = 14;
                  break;
                }

                error = new Error(APPLE_DIST_CERTS_TOO_MANY_GENERATED_ERROR);

                error.code = 'APPLE_DIST_CERTS_TOO_MANY_GENERATED_ERROR';
                throw error;

              case 14:
                throw _context2.t0;

              case 15:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2, [[0, 7]]);
      }))();
    },
    revoke: function revoke(ids) {
      var _this3 = this;

      return (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3() {
        var args;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                args = ['revoke', appleId, appleIdPassword, team.id, team.inHouse, ids.join(',')];
                _context3.next = 3;
                return (0, (_fastlane || _load_fastlane()).runAction)((_fastlane || _load_fastlane()).travelingFastlane.manageDistCerts, args);

              case 3:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this3);
      }))();
    },
    format: function format(_ref3) {
      var name = _ref3.name,
          id = _ref3.id,
          status = _ref3.status,
          expires = _ref3.expires,
          created = _ref3.created,
          ownerName = _ref3.ownerName;

      var expiresDate = _formatTimestamp(expires);
      var createdDate = _formatTimestamp(created);
      return name + ' (' + status + ') - ID: ' + id + ' - expires: ' + expiresDate + ' (created: ' + createdDate + ') - owner: ' + ownerName;
    }
  };
};

var _formatTimestamp = function _formatTimestamp(timestamp) {
  return (0, (_dateformat || _load_dateformat()).default)(new Date(timestamp * 1000));
};

exports.default = createManager;
module.exports = exports['default'];
//# sourceMappingURL=../../../../__sourcemaps__/commands/build/ios/appleApi/distributionCert.js.map
