'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkIfSdkIsSupported = undefined;

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var checkIfSdkIsSupported = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(sdkVersion, platform) {
    var isSupported, storeName;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (_xdl || _load_xdl()).Versions.canTurtleBuildSdkVersion(sdkVersion, platform);

          case 2:
            isSupported = _context.sent;

            if (isSupported) {
              _context.next = 7;
              break;
            }

            storeName = platform === 'ios' ? 'Apple App Store' : 'Google Play Store';

            (_log || _load_log()).default.error((_chalk || _load_chalk()).default.red('Unsupported SDK version: our app builders don\'t have support for ' + sdkVersion + ' version yet. Submitting the app to the ' + storeName + ' may result in an unexpected behaviour'));
            throw new Error('Unsupported SDK version');

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function checkIfSdkIsSupported(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _xdl;

function _load_xdl() {
  return _xdl = require('@expo/xdl');
}

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _log;

function _load_log() {
  return _log = _interopRequireDefault(require('../../log'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.checkIfSdkIsSupported = checkIfSdkIsSupported;
//# sourceMappingURL=../../__sourcemaps__/commands/build/utils.js.map
