'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateBundleIdentifier;

var _crypto = _interopRequireDefault(require('crypto'));

var _base;

function _load_base() {
  return _base = require('base32.js');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function generateBundleIdentifier(teamId) {
  return 'dev.expo.client.' + base32(sha(teamId));
}

function sha(data) {
  var hash = _crypto.default.createHash('sha224');
  return hash.update(data).digest();
}

function base32(buffer) {
  var encoder = new (_base || _load_base()).Encoder({
    type: 'rfc4648',
    lc: true /* lowercase */
  });
  return encoder.write(buffer).finalize();
}
module.exports = exports['default'];
//# sourceMappingURL=../../__sourcemaps__/commands/client/generateBundleIdentifier.js.map
