'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var _path = _interopRequireDefault(require('path'));

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _CommandError;

function _load_CommandError() {
  return _CommandError = _interopRequireDefault(require('../../CommandError'));
}

var _promptQuestionsAsync;

function _load_promptQuestionsAsync() {
  return _promptQuestionsAsync = _interopRequireDefault(require('./promptQuestionsAsync'));
}

var _configureModule;

function _load_configureModule() {
  return _configureModule = _interopRequireDefault(require('./configureModule'));
}

var _fetchTemplate;

function _load_fetchTemplate() {
  return _fetchTemplate = _interopRequireDefault(require('./fetchTemplate'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(newModuleProjectDir, options) {
    var newModulePathFromArgv, newModuleName, newModuleParentPath, configuration, newModulePath;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            newModulePathFromArgv = newModuleProjectDir && _path.default.resolve(newModuleProjectDir);
            newModuleName = newModulePathFromArgv && _path.default.basename(newModulePathFromArgv);
            newModuleParentPath = newModulePathFromArgv ? _path.default.dirname(newModulePathFromArgv) : process.cwd();
            _context.next = 5;
            return (0, (_promptQuestionsAsync || _load_promptQuestionsAsync()).default)(newModuleName);

          case 5:
            configuration = _context.sent;
            newModulePath = _path.default.resolve(newModuleParentPath, configuration.npmModuleName);
            _context.next = 9;
            return (_fsExtra || _load_fsExtra()).default.exists(newModulePath);

          case 9:
            if (!_context.sent) {
              _context.next = 11;
              break;
            }

            throw new (_CommandError || _load_CommandError()).default('MODULE_ALREADY_EXISTS', 'Module \'' + newModulePath + '\' already exists!');

          case 11:
            _context.next = 13;
            return (0, (_fetchTemplate || _load_fetchTemplate()).default)(newModulePath, options.template);

          case 13:
            _context.next = 15;
            return (0, (_configureModule || _load_configureModule()).default)(newModulePath, configuration);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function generateModuleAsync(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return generateModuleAsync;
}();

module.exports = exports['default'];
//# sourceMappingURL=../../__sourcemaps__/commands/generate-module/generateModuleAsync.js.map
