"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getExpoDomainUrl = getExpoDomainUrl;
exports.constructBuildLogsUrl = constructBuildLogsUrl;
exports.constructTurtleStatusUrl = constructTurtleStatusUrl;
exports.constructArtifactUrl = constructArtifactUrl;
function getExpoDomainUrl() {
  if (process.env.EXPO_STAGING) {
    return "https://staging.expo.io";
  } else if (process.env.EXPO_LOCAL) {
    return "http://expo.test";
  } else {
    return "https://expo.io";
  }
}

function constructBuildLogsUrl(buildId) {
  return getExpoDomainUrl() + "/builds/" + buildId;
}

function constructTurtleStatusUrl() {
  return getExpoDomainUrl() + "/turtle-status";
}

function constructArtifactUrl(artifactId) {
  return getExpoDomainUrl() + "/artifacts/" + artifactId;
}
//# sourceMappingURL=../../__sourcemaps__/commands/utils/url.js.map
